<template>
    <div class="vlow-node vlow-node-decision-table" :rel="content.id" :style="{'--rows':rows, '--columns': columns}">
      <div
          class="title"
          v-text="proto.title"
          @mousedown.prevent="$emit('start-drag', $event)"
      />
      <template v-for="(cfg, input, n) in proto.inputs" :key="input+'pin'">
        <div

            :class="'name left row'+n"
            v-text="cfg.label || input"
        />

        <div
            v-if="content.node[input].type === 'connection'"
            :rel="input"
            :class="'input left row'+n"
            v-html="'&middot;'"
        />

        <div
            v-if="content.node[input].type === 'constant'"
            :class="'value left row'+n"
            v-text="content.node[input].constant.value"
        />
      </template>

      <template v-for="(cfg, output, n) in proto.outputs" :key="output+'dot'">
        <div

            :rel="output"
            :class="'output right row'+(n + Object.keys(proto.inputs).length)"
            v-html="'&middot;'"
        />
      </template>

      <template v-for="(column, c) in content.node.mapping.constant.value" :key="c">
        <template v-for="(row, r) in column[0]" :key="r">
          <div :class="['row'+r, 'col'+c]">{{row?'T':'F'}}</div>
        </template>
      </template>
    </div>
  </template>

<script>
  import {getRowsInNodeProto} from "../../utils.js";

  export default {
    name: "custom-node-decisionTable",
    props: {
      proto: Object,
      content: Object
    },
    computed: {
      rows() {
        return getRowsInNodeProto(this.proto)
      },
      columns () {
        return this.content.node.mapping.constant.value.reduce((a,b)=>a + b.length, 0)
      }
    }
  }
</script>

<style lang="scss">
  .vlow-node-decision-table {
    grid-template-columns: 15px auto minmax(5px, auto) repeat(var(--columns), 1fr) 15px !important;

    @for $i from 0 through 9 {
      .col#{$i} {
        grid-column: #{$i + 4};
      }
    }
  }
</style>
